'************************************************************************
'
'       TRANSFORMATION DEMANDE CLIENT/ACCESS EN REQUETE SQL/400
'
' Le nom du fichier .dtf est pass en paramtre au script.
' Celui-ci extrait du fichier les instructions sql et recompose	une
' requete en format as/400
' Le rsultat est transfr  notepad pour etre copi dans le presse-papiers.
' Il reste ensuite dans la session as400  coller la requete.
'
' DJ 08.03.2010
'
'************************************************************************

option explicit

'*** DEFINITION DES VARIABLES

'* objets script
dim wwsh
dim fso
dim nom_fent:' fichier demande .dtf
dim fent

'* variables gnerales
const msgtitre="DTF en SQL"
const largeur_sql=68

'* requetes
dim treq(15)
dim nb : 'nombre de lignes en format final

trtgeneral


'*** TRAITEMENT GENERAL
sub trtgeneral()

'initialisation
set wwsh=createobject("wscript.shell")
set fso=createobject("scripting.filesystemobject")

' vrif parametres
if lecture_params=0 then
        dim x
        x=msgbox("Passer le nom du fichier dtf en parametre", 0, msgtitre)
        wscript.quit
end if

' transformer la requete
traiter_requete

' copier le rsultat dans le presse-papiers
copier_requete

end sub




'*** VERIFICATION DES PARAMETRES
' On doit recevoir en paramtre un nom de fichier .dtf existant

function lecture_params()

        dim x

        lecture_params=0

        ' rcupration paramtres; 1 seul
        set x=wscript.arguments
        if x.count <> 1 then
            exit function
        end if

        ' vrif existence fichier
        if not fso.FileExists(x(0)) Then
                exit function
        end if

        ' controle ok
        lecture_params=1
        nom_fent=x(0)
        
end function





'*** TRADUIRE LA REQUETE
' Traduit la requete client/access en sql
' et la dimensionne pour collage dans une session 400

function traiter_requete()

        dim liglue
        dim vselect, vfrom, vwhere, vgroup, vhaving, vorder
        dim i
        
        '* raz des rsultats
        for i = 1 to 15 : treq(i)="" : next
        vselect=""
        vfrom=""
        vwhere=""
        vgroup=""
        vhaving=""
        vorder=""

        '* ouverture de la demande dtf
        set fent=fso.OpenTextFile(nom_fent, 1, false, -1)

        '* lecture des lignes pour extraire les mots-cls de la requete
        while not fent.atendofstream
            liglue=fent.readline
            if left(liglue, 7)="Select=" then vselect=trt_select(liglue)
            if left(liglue, 9)="HostFile=" then vfrom=trt_from(liglue)
            if left(liglue, 6)="Where=" then vwhere=trt_where(liglue)
            if left(liglue, 8)="GroupBy=" then vgroup=trt_group(liglue)
            if left(liglue, 7)="Having=" then vhaving=trt_having(liglue)
            if left(liglue, 8)="OrderBy=" then vorder=trt_order(liglue)
        wend
        fent.close

        '* clater les expressions en chaines de 75 caractres
        nb=0
        eclate vselect, "SELECT"
        eclate vfrom, "FROM"
        if vwhere <>"" then eclate vwhere, "WHERE"
        if vgroup <>"" then eclate vgroup, "GROUP BY"
        if vhaving <>"" then eclate vhaving, "HAVING"
        if vorder <>"" then eclate vorder, "ORDER BY"

end function



' TRAITER LE SELECT
function trt_select(plig)

        trt_select=trait_esp (mid (plig,8))

end function

' TRAITER LE FROM
' Retrouver chaque nom de fichier pour y accoler t1, t2, ...
function trt_from(plig)

        dim xxx
        dim x, i
        
        x=""
        xxx=split(mid(plig, 10), ",", -1)
        for i = 0 to ubound(xxx)
            x=x+xxx(i)+" t"+cstr(i+1)
            if i <> ubound(xxx) then x=x+", "
        next
        
        trt_from=x

end function

' TRAITER LE WHERE
function trt_where(plig)

        trt_where=trait_esp(mid(plig, 7))

end function

' TRAITER LE GROUP BY
function trt_group(plig)

        trt_group=mid(plig, 9)

end function

' TRAITER LE HAVING
function trt_having(plig)

        trt_having=mid(plig, 8)

end function

' TRAITER LE ORDER
function trt_order(plig)

        trt_order=mid(plig, 9)

end function



' SUPPRIMER LES ESPACES INUTILES

function trait_esp (plig)

		dim xxx, xxn

		dim i 
		dim xcar
		dim indquote
		dim nbesp

		xxx=plig
		xxn=""
		indquote=0
		nbesp=0

		for i = 1 to len(xxx)
			xcar=mid(xxx,i,1)
			if xcar=" " then nbesp=nbesp+1 else nbesp=0
			if xcar=" " and indquote=0 and nbesp > 1 then xcar="" 
			if xcar="'" then indquote=1-indquote
			xxn=xxn+xcar
		next 

	    trait_esp=xxn

end function





' ECLATER LA CHAINE
' On spare les mots par des blancs ou des ',' , non compris entre ''
function eclate(pstr, ppref)

        dim motlig, motind, mot
        dim lett, i
        dim indquote
        
        motlig=""
        motind=""
        indquote=0
        
        mot=ppref+" "+pstr +" ": 'ajouter un espace pour finir le dernier mot
        
        for i =  1 to len(mot)
            lett=mid(mot, i, 1)
            if lett="'" then indquote=1-indquote
            motind=motind+lett

            ' a la rencontre d'un blanc, crer nouvelle ligne si taille atteinte
            if (lett=" " or lett=",") and indquote=0 then
                if len(motind) > (largeur_sql-len(motlig)) then
                    nb=nb+1
                    treq(nb)=motlig
                    motlig=""
                end if
                motlig=motlig+motind
                motind=""
            end if
        next
        nb=nb+1
        treq(nb)=motlig
        
end function





'*** COPIER LE RESULTAT
' Exporte le resultat vers notepad pour ensuite le copier dans le presse-papiers

function copier_requete()

        dim x
        dim i
        
        ' Ouvrir notepad avec temps d'attente
        x=wwsh.run("notepad" , 9)
        WScript.Sleep 500

        ' y envoyer les lignes de la requete
        for i = 1 to 15
            if trim(treq(i))<>"" then
                ' certains caractres ncessitent une codif spciale
                treq(i)=replace(treq(i), "(","{(}")
                treq(i)=replace(treq(i), ")","{)}")
                treq(i)=replace(treq(i), "%","{%}")
                wwsh.sendkeys treq(i)+"{ENTER}"
            end if
        next

        ' ... copier tout dans le presse-papiers
        wwsh.sendkeys "^a^c"
        
        ' ... fermer notepad sans sauvegarder
        wwsh.sendkeys "%fqn"

end function


