'************************************************************************
'
'       TRANSFORMATION REQUETE SQL/400 EN DEMANDE CLIENT/ACCESS
'
' La requete sql est copie dans le presse-papier et enregistre dans un
' fichier. Le programme extrait du fichier les instructions sql et recompose,
' via un modle, une demande de transfert.
' Le rsultat est stock dans un fichier dtf temporaire qu'il suffit de
' conserver.
'
' Fichiers utiliss:
'	. sqlendtf.vbs : le programme de conversion
'	. sqlendtf.dtf : demande de transfert modle
' 	. sqlendtf.txt : fichier intermdiaire (collage du presse-papiers)
'
'	Les fichiers portent le nom du script et se trouvent tous dans 
'	le mme rpertoire
'
'
' DJ 08.03.2010
'
'************************************************************************


option explicit

'*** DEFINITION DES VARIABLES

'* objets script
dim wwsh
dim fso
dim chem
dim nom_ftxt
dim nom_fent
dim nom_fsor
dim fent

'* requete sql
dim vselect, vfrom, vwhere, vgroup, vhaving, vorder

'* variables gnerales
const msgtitre="SQL en DTF"
dim tfic(10), tpref(10), tnouv(10):' alias fichiers

trtgeneral



'*** TRAITEMENT GENERAL
sub trtgeneral()

'initialisation
set wwsh=createobject("wscript.shell")
set fso=createobject("scripting.filesystemobject")
'... chemin d'accs du script pour fichiers de travail
chem=replace(wscript.scriptfullname, wscript.scriptname,"")
nom_ftxt=replace(wscript.scriptname,".vbs",".txt" )

' rcuprer la requete dans le presse-papier
copier_requete

' transformer la requete sql
if traiter_requete = 0 then
	dim xret
	xret=msgbox("Requete non valide", 0, msgtitre)
	wscript.quit
end if

'crer le fichier dtf
creer_dtf
xret=msgbox("La demande de transfert est cre sous le nom"+vbcrlf+ucase(nom_fsor), 0, msgtitre)

end sub




'*** TRADUIRE LA REQUETE
' Traduit la requete sql en mots-cls client/access
' Il faut :
'	. d'abord localiser les mot-cls sql dans la chaine totale
'	. extraire pour chaque mot cl la partie variable
'	. identifier dans le FROM les alias de fichiers s'ils existent
'	. remplacer ces alias par des nouveaux en T1, T2
' Pour faciliter les traitements, toute la chaine doit tre ne majuscules, sauf les 
' chaines constantes

function traiter_requete()

        dim liglue, xxx, indquote, xcar
        dim isel, ifro, iwhe, igro, ihav, iord
		dim imot(7)
		dim i
        dim nbesp

		traiter_requete=0

		'* raz des rsultats
        vselect=""
        vfrom=""
        vwhere=""
        vgroup=""
        vhaving=""
        vorder=""

        '* lecture de la requete (par ligne, pour liminer les crlf)
        set fent=fso.OpenTextFile(chem+nom_ftxt, 1, false)
        xxx=""
		while not fent.atendofstream
		    xxx=xxx+fent.readline
        wend
		' mise en majuscules
		liglue=""
		indquote=0
		nbesp=0

		for i = 1 to len(xxx)
			xcar=mid(xxx, i, 1)
			if xcar=" " then nbesp=nbesp+1 else nbesp=0
			if indquote=0 and xcar=" " and nbesp > 1 then xcar="":' effacer les espaces supplmentaires
			if xcar="'" then indquote=1-indquote
			if xcar="'" or indquote=1 then
				liglue=liglue+xcar
			else
				liglue=liglue+ucase(xcar)
			end if
		next 
        fent.close

        '* clater les expressions
        isel=instr(1, liglue, "SELECT")
        ifro=instr(1, liglue, "FROM")
        iwhe=instr(1, liglue, "WHERE")
        igro=instr(1, liglue, "GROUP")
        ihav=instr(1, liglue, "HAVING")
        iord=instr(1, liglue, "ORDER")

		' test si requete valide (select et from obligatoires)
		if isel=0 or ifro = 0 then 
			exit function
		end if

		' dterminer les frontires de chaque mot-cl par rapport au suivant, plusieurs tant facultatifs
		imot(1)=isel
		imot(2)=ifro
		i=2
		if iwhe <>0 then i=i+1:	imot(i)=iwhe
		if igro <>0 then i=i+1: imot(i)=igro
		if ihav <>0 then i=i+1: imot(i)=ihav
		if iord <>0 then i=i+1: imot(i)=iord
		i=i+1: imot(i)=len(liglue)+1

		' calculer un mot cl, de sa position de dbut jusqu'au mot cl suivant
		vfrom=trt_from(liglue, imot(2), imot(3)):' pour transformer les alias fichiers
		vselect=trt_select(liglue, imot(1), imot(2))
		i=2
		if iwhe > 0 then i=i+1: vwhere=trt_where(liglue, imot(i), imot(i+1))
		if igro > 0 then i=i+1: vgroup=trt_group(liglue, imot(i), imot(i+1))
		if ihav > 0 then i=i+1: vhaving=trt_having(liglue, imot(i), imot(i+1))
		if iord > 0 then i=i+1: vorder=trt_order(liglue, imot(i), imot(i+1))
		
		traiter_requete=1
		
end function



' *** TRAITER LE SELECT
' Extraire la partie variable puis remplacer les alias fichiers

function trt_select(plig, pdeb, pfin)

        trt_select=sql_replace(plig, pdeb, pfin, "SELECT")
		trt_select=remplace_alias(trt_select)

end function



' *** TRAITER LE FROM
' Rcuprer l'instruction from
' Rechercher les alias fichiers pour les transformer en t1, t2 ...

function trt_from(plig, pdeb, pfin)

		dim xxx
        dim x, i, j
        dim yyy
		dim zzz

		' rcup du from
		xxx=mid(plig, pdeb, pfin  - pdeb)
		xxx=mid(xxx,5)
		xxx=trim(xxx)

		' rcuprer les noms de fichiers (sans "bib/", avec alias qui suit un blanc)
        x=""
        j=0
		' tableau des noms complets
		yyy=split(xxx, ",", -1)
        for i = 0 to ubound(yyy)
			zzz=trim(yyy(i)):' saug=vegarder le nom avec bib.

			' calculer le nom sans la bib (sert en cas d'absence d'alias)
			x=instr(1, yyy(i),"/")
			if x<>0 then yyy(i)=mid(yyy(i), x+1)
			yyy(i)=trim(yyy(i))

			j=j+1
			
			' recherche si alias (spar par un blanc)
			x=instr(1, zzz, " ")
			if x > 0 then
				' presence d'alias (le conserver et l'enlever du fichier)
				tfic(j)=trim(left(zzz, x-1))
				tpref(j)=trim(mid(zzz, x))
			else
				' absence d'alias (alias=nom court du fichier)
				tfic(j)=trim(zzz)
				tpref(j)=yyy(i) 
			end if
			
			' nouvel alias
			tnouv(j)="T"+cstr(j)
        next
        
		' calculer la nouvelle instruction from (noms de fichiers complets + nouveaux alias)
		xxx=""
		for i = 1 to j
			xxx=xxx+tfic(i)+" "
			if i<>j then xxx=xxx+", "
		next 
		
		trt_from=xxx

end function



' *** TRAITER LE WHERE

function trt_where(plig, pdeb, pfin)

        trt_where=sql_replace(plig, pdeb, pfin, "WHERE")
		trt_where=remplace_alias(trt_where)

end function



' *** TRAITER LE GROUP BY

function trt_group(plig, pdeb, pfin)

        trt_group=sql_replace(plig, pdeb, pfin, "GROUP")
		trt_group=remplace_alias(trt_group)

end function



' *** TRAITER LE HAVING

function trt_having(plig, pdeb, pfin)

        trt_having=sql_replace(plig, pdeb, pfin, "HAVING")
		trt_having=remplace_alias(trt_having)

end function

' *** TRAITER LE ORDER

function trt_order(plig, pdeb, pfin)

        trt_order=sql_replace(plig, pdeb, pfin, "ORDER")
		trt_order=remplace_alias(trt_order)

end function



' *** EXTRACTION DU TEXTE D'UN MOT-CLE SQL
' Enlve le mot cl de la phrase sql

function sql_replace(plig, pdeb, pfin, pmot)

        dim xxx
		
		xxx=mid(plig, pdeb, pfin-pdeb)
		xxx=trim(xxx)
		if pmot="SELECT" then xxx=trim(mid(xxx, 7))
		if pmot="FROM" then xxx=trim(mid(xxx, 5))
		if pmot="WHERE" then xxx=trim(mid(xxx, 6))
		if pmot="GROUP" then 
			xxx=trim(mid(xxx, 7))
			xxx=trim(mid(xxx, 3)):' by
		end if
		if pmot="HAVING" then xxx=trim(mid(xxx, 7))
		if pmot="ORDER" then 
			xxx=trim(mid(xxx, 6))
			xxx=trim(mid(xxx, 3)):' by
		end if

		sql_replace=xxx
        
end function



' *** REMPLACER LES ALIAS DE FICHIERS 
' Les alias sont identifis par xxxxxx.yyyyyyyyy. Modifier la partie xxxxxx

function remplace_alias(pmot)

	dim xxx
	dim i

	xxx=pmot
	

	for i = 1 to 10
		if tfic(i)<>"" then
			xxx=replace(xxx, tpref(i)+".", tnouv(i)+".") 	
		end if
	next 

	remplace_alias=xxx

end function



' *** RECUPERER LA REQUETE
' Copie le presse-papier dans notepad et l'enregistre dans un fichier

function copier_requete()

        dim x
        
        ' Supprimer le fichier s'il existe pour viter confirmation de sauvegarde
        if fso.fileexists(chem+nom_ftxt) then
                fso.deletefile(chem+nom_ftxt)
        end if

        ' Ouvrir notepad avec temps d'attente
        x=wwsh.run("notepad" , 9)
        WScript.Sleep 500

        ' ... copier tout le presse-papiers
        wwsh.sendkeys "^v"

        ' ... sauvegarder dans le fichier texte
        wwsh.sendkeys("^s"+chem+nom_ftxt+"{ENTER}")

       ' ... fermer notepad
        wwsh.sendkeys "%fq"

		' Le dlai sert  l'excution des sendkeys, sinon erreur dans la suite du traitement
		WScript.Sleep 2000

end function



'*** CREER LA DTF FINALE A PARTIR D'UN MODELE
' Lit le modle et remplace les variables mots_cls par leur valeur relle

function creer_dtf()

	dim fent, fsor
	dim xxx
	dim xuni

	nom_fent=replace(wscript.scriptname,".vbs",".dtf"):' -> script.dtf
	nom_fsor=replace(wscript.scriptname,".vbs","")+"fic.dtf":' -> scriptFIC.dtf

	' Dterminer s'il s'agit d'un fichier ascii ou unicode
	set fent=fso.opentextfile(chem+nom_fent, 1, true, 0)
	xxx=fent.readline
	if left(xxx,2)=chr(255)+chr(254) then
		xuni=-1: 'unicode
	else 
		xuni=0: ' ascii
	end if
	fent.close
	
	' Lire le modle
	set fent=fso.opentextfile(chem+nom_fent, 1, true, xuni)
	set fsor=fso.opentextfile(chem+nom_fsor, 2, true, 0)
	while not fent.atendofstream
		xxx=fent.readline
		if left(xxx,7)="Select=" then xxx="Select="+vselect
		if left(xxx,9)="HostFile=" then xxx="HostFile="+vfrom
		if left(xxx,6)="Where=" then xxx="Where="+vwhere
		if left(xxx,8)="GroupBy=" then xxx="GroupBy="+vgroup
		if left(xxx,7)="Having=" then xxx="Having="+vhaving
		if left(xxx,8)="OrderBy=" then xxx="OrderBy="+vorder
		fsor.writeline xxx
	wend
	fent.close
	fsor.close

end function
